#<profile4xi profile = "12" />
# -------------------------------------------------------------------------------------------------
#<program4xi program = "kskeleton4xi.py">
#<abstract4xi abstract = "offers skeleton for functions and classes starting with k/K"/>
#<refer4xi reference = "skeleton_print4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'init_kskeleton4xi', 'KSkeleton4Xi'  ]
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys 
import threading
import _thread
from decimal import *
#"
#/>
# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
try:                 # system ones
    import os
    import sys
    import signal
except:
    pass
try:
    import _winapi
except:
    pass

                
try:                 # threading ones       
    import threading                
    import _thread   
except:
    pass
try:                 # most-common ones
    from decimal import *       
except:
    pass
try:                 # rare ones
    pass         
except:
    pass 
try:                 # imported-as ones 
    pass          
except:
    pass            
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from ace_object4xi import ace_object4xi
from print4xi import print4xi
from reason_object4xi import reason_object4xi
from sense_object4xi import sense_object4xi
from time4xi import time4xi
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi globals                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global killerwhale4xi
#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
killer4xi = "Killer Whale"
#"
#"/>
 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "init-kskeleton4xi" usage = "
#   initializes killer4xi
#"> 
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; ACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------   
def init_kskeleton4xi(init_param = "Killer Whale"): 
    '''
    initializes killer4xi
    '''
    # ---------------------------------------------------------------------------------------------
    # 
    # ---------------------------------------------------------------------------------------------    
    global killer4xi
          
    class2print = "init_kskeleton4xi"
    method2print = "init_kskeleton4xi"
   
    message2print = "{started" + "; init-kskeleton4xi-started: " + str(init_kskeleton4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)            
        
    message2print = "{passed" + "; init-param-passed-to-init-kskeleton4xi: " + str(init_param) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)   
    
    # ---------------------------------------------------------------------------------------------
    # 
    # ---------------------------------------------------------------------------------------------    
    
    killer4xi = init_param
    
    message2print = "{initialized" + "; killer4xi-initialized-by-init-kskeleton4xi to: " + str(killer4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)    
            
    
    # ---------------------------------------------------------------------------------------------
    # 
    # ---------------------------------------------------------------------------------------------                
    message2print = "{returning" + "; init-kskeleton4xi-returning: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)      
          
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "set-kskeleton4xi" usage = "
# setializes kskeleton4xi objects
#"> 
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------   
def set_kskeleton4xi(z_set_param1 = None): 
    '''
    set_kskeleton4xi sets kskeleton4xi objects
    '''

    # -----------------------------------------------------------------------------------------
    # (Step 1/3)           
    # -----------------------------------------------------------------------------------------          
    class2print = "set_kskeleton4xi"
    method2print = "set_kskeleton4xi"

    message2print = "{(Step 1/3a) started" + "; set-kskeleton4xi-started: " + str(set_kskeleton4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
        
    message2print = "{(Step 1/3b) passed" + "; z-set-param1-passed-to-set-kskeleton4xi: " + str(z_set_param1) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
    
    # -----------------------------------------------------------------------------------------
    # (Step 2/3)       
    # -----------------------------------------------------------------------------------------                  
    z2xi = z_set_param1            
    
    message2print = "{(Step 2/3) initialized" + "; z2xi-initialized-by-set-kskeleton4xi to: " + str(z2xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)    
        

    # -----------------------------------------------------------------------------------------
    # (Step 3/3)           
    # -----------------------------------------------------------------------------------------
    message2print = "{(Step 3/3) returning" + "; set-kskeleton4xi-returning: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)      
        
#</function4xi>
 
# -------------------------------------------------------------------------------------------------
#<function4xi function = "get-kskeleton4xi" usage = "
#   gets kskeleton4xi objects
#"> 
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------   
def get_kskeleton4xi(): 
    '''
    get_kskeleton4xi gets kskeleton4xi objects
    '''

    # -----------------------------------------------------------------------------------------
    # (Step 1/3)           
    # -----------------------------------------------------------------------------------------          
    class2print = "get_kskeleton4xi"
    method2print = "get_kskeleton4xi"

    message2print = "{(Step 1/3) started" + "; get-kskeleton4xi-started: " + str(get_kskeleton4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
        

    
    # -----------------------------------------------------------------------------------------
    # (Step 2/3)       
    # -----------------------------------------------------------------------------------------                  
    
    z2xi = "z2xi"
        
    message2print = "{(Step 2/3) got" + "; z2xi-got-by-get-kskeleton4xi: " + str(z2xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
                
    # -----------------------------------------------------------------------------------------
    # (Step 3/3)           
    # -----------------------------------------------------------------------------------------
    
    message2print = "{returning" + "; z2xi-returning-by-get-kskeleton4xi: " + str(z2xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)    
                            
    
    return z2xi     
        
#</function4xi>
                                                            
# =================================================================================================
# KSkeleton4Xi class
#<class4xi class = "KSkeleton4Xi" base = "object" child = "None" synopsis = "Skeleton class for modules starting witk k"
#   usage = "creating new programs"
#>
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; ACK4systemtesting"/>
# =================================================================================================
class KSkeleton4Xi(object): 
    ''' 
    offers class KSkeleton4Xi services
    '''            
    # ---------------------------------------------------------------------------------------------
    # Public API of this class
    # ---------------------------------------------------------------------------------------------    
    #<expose4xi expose = "
    _exposed_ = ('init_kskeleton','get_kskeleton','set_kskeleton','sense', 'reason', 'ace')          
    #"
    #/>
                                 
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "init-of-KSkeleton4Xi" usage = "initializes KSkeleton4Xi">
    #<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; ACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------   
    def __init__(self, killer="Killer Whale"):
        '''
        initializes KSkeleton4Xi 
        '''       
        class2print = "KSkeleton4Xi"
        method2print = "__init__"
        
        # -------------------------------------------------------------------------------------------------------------------------------------------
        message2print = "{(Step 1/4) stepping" + "; (Step 1/4)-stepping-by-init-of-KSkeleton4Xi: " + "~~"  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # -------------------------------------------------------------------------------------------------------------------------------------------        

        message2print = "{(Step 1/4a) started" + "; init-of-KSkeleton4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
                         
        message2print = "{(Step 1/4b) passed" + "; killer-passed-to-init-of-KSkeleton4Xi: " + str(killer) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)           
        
        message2print = "(Step 1/4c) borning" + "; kskeleton2xi-of-KSkeleton4Xi-borning: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        
        message2print = "{(Step 1/4d) inheriting" + "; object-inheriting-by-kskeleton2xi-of-KSkeleton4Xi: " + str(object)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
                
        # -------------------------------------------------------------------------------------------------------------------------------------------
        message2print = "{(Step 2/4) stepping" + "; (Step 2/4)-stepping-by-init-of-KSkeleton4Xi: " + "~ setting object values ~"  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # -------------------------------------------------------------------------------------------------------------------------------------------        
                          
        self._classification = "killers"
        
        message2print = "{(Step 2/4a)  set" + "; classification-of-kskeleton2xi-set-by-init-of-KSkeleton4Xi to: " + str(self._classification)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
                
        self._environment = "sea"
        
        message2print = "{(Step 2/4b)  set" + "; environment-of-kskeleton2xi-set-by-init-of-KSkeleton4Xi to: " + str(self._environment)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
              
        self._pray = "pinguin"
        
        message2print = "{(Step 2/4c)  set" + "; pray-of-kskeleton2xi-set-by-init-of-KSkeleton4Xi to: " + str(self._pray)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
              
        self._environment = "Antarctica"
        
        message2print = "{(Step 2/4d)  set" + "; environment-of-kskeleton2xi-set-by-init-of-KSkeleton4Xi to: " + str(self._environment)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
              

        # -------------------------------------------------------------------------------------------------------------------------------------------
        message2print = "{(Step 3/4) stepping" + "; (Step 3/4)-stepping-by-init-of-KSkeleton4Xi: " + "~~"  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # -------------------------------------------------------------------------------------------------------------------------------------------        
         
        message2print = "{(Step 3/4a) passing" + "; killer-passing-to-init-kskeleton4xi-by-init-of-KSkeleton4Xi: " + str(killer) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
                
        try:                     
            init_kskeleton4xi(killer)
        
            message2print = "{(Step 3/4b) performed" + "; init-kskeleton4xi-performed-by-init-of-KSkeleton4Xi: " + str(init_kskeleton4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)             
        except:
            message2print = "{(Step 3/4c) hit" + "; init-kskeleton4xi-hit-by-init-of-KSkeleton4Xi: " + " *** " + str(init_kskeleton4xi)  + " *** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            
            raise
          

        # -------------------------------------------------------------------------------------------------------------------------------------------
        message2print = "{(Step 4/4) stepping" + "; (Step 4/4)-stepping-by-init-of-KSkeleton4Xi: " + "~~"  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # -------------------------------------------------------------------------------------------------------------------------------------------        
        
        message2print = "{(Step 1/4a) inherited" + "; object-inherited-by-kskeleton2xi-of-KSkeleton4Xi: " + str(object)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
                     
        message2print = "{(Step 4/4b) activated" + "; kskeleton2xi-of-KSkeleton4Xi-activated: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
                 
                                        
        message2print = "{(Step 4/4c) returning" + "; init-of-KSkeleton4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
                      

    #</methodize4xi>
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "init-kskeleton-of-KSkeleton4Xi" usage = "initializes killer">
    #<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; ACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------   
    def init_kskeleton(self, killer="Killer Whale"):
        '''
        initializes killer
        '''       
     
        class2print = "KSkeleton4Xi"
        method2print = "init_kskeleton"
        
        # -------------------------------------------------------------------------------------------------------------------------------------------
        message2print = "{(Step 1/3) stepping" + "; (Step 1/3)-stepping-by-init-kskeleton-of-KSkeleton4Xi: " + "~~"  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # -------------------------------------------------------------------------------------------------------------------------------------------        


        message2print = "{(Step 1/3a) started" + "; init-kskeleton-of-KSkeleton4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
   
        message2print = "{(Step 1/3a) passed" + "; killer-passed-to-init-kskeleton-of-KSkeleton4Xi: " + str(killer) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                   

        # -------------------------------------------------------------------------------------------------------------------------------------------
        message2print = "{(Step 2/3) stepping" + "; (Step 2/3)-stepping-by-init-kskeleton-of-KSkeleton4Xi: " + "~~"  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # -------------------------------------------------------------------------------------------------------------------------------------------        
              
        
        message2print = "{passing" + "; killer-passing-to-init-kskeleton4xi-by-init-kskeleton-of-KSkeleton4Xi: " + str(killer) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
                
        init_kskeleton4xi(killer)
        
        message2print = "{performed" + "; init-kskeleton4xi-performed-by-init-kskeleton-of-KSkeleton4Xi: " + str(init_kskeleton4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
                   

        # -------------------------------------------------------------------------------------------------------------------------------------------
        message2print = "{(Step 3/3) stepping" + "; (Step 3/3)-stepping-by-init-kskeleton-of-KSkeleton4Xi: " + "~~"  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # -------------------------------------------------------------------------------------------------------------------------------------------        

        message2print = "{returning" + "; init-kskeleton-of-KSkeleton4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
    #</methodize4xi>
       

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "set-kskeleton-of-ZSkeleton4Xi" usage = "sets objects of ZSkeleton4Xi">
    #<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------   
    def set_kskeleton(self, z_set_param1 = None):
        '''
        set_kskeleton method sets objects of ZSkeleton4Xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/3)           
        # -----------------------------------------------------------------------------------------              
        class2print = "ZSkeleton4Xi"
        method2print = "set_kskeleton"
                     
        message2print = "{(Step 1/3a) started" + "; set-kskeleton-of-ZSkeleton4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
            
        message2print = "{(Step 1/3b) passed" + "; z-set-param1-passed-to-set-kskeleton-of-ZSkeleton4Xi: " + str(z_set_param1) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                      
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/3)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2/3a) passing" + "; z-set-param1-passing-to-set-kskeleton4xi-by-set-kskeleton-of-ZSkeleton4Xi: " + str(z_set_param1) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
                
  
        set_kskeleton4xi(z_set_param1)

        message2print = "{(Step 2/3b) performed" + "; set-kskeleton4xi-performed-by-set-kskeleton-of-ZSkeleton4Xi: " + str(set_kskeleton4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/3)           
        # ----------------------------------------------------------------------------------------- 
        message2print = "{(Step 3/3) returning" + "; set-kskeleton-of-ZSkeleton4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
                                
                            
    #</methodize4xi>

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "get-kskeleton-of-ZSkeleton4Xi" usage = "gets objects of ZSkeleton4Xi">
    #<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------   
    def get_kskeleton(self):
        '''
        get_kskeleton method gets objects of ZSkeleton4Xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/2)           
        # -----------------------------------------------------------------------------------------              
        class2print = "ZSkeleton4Xi"
        method2print = "get_kskeleton"
                     
        message2print = "{(Step 1/2) started" + "; get-kskeleton-of-ZSkeleton4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
            

        # -----------------------------------------------------------------------------------------
        # (Step 2/2)           
        # ----------------------------------------------------------------------------------------- 
        message2print = "{(Step 2/2) returning" + "; get-kskeleton4xi-function-returning-by-get-kskeleton-of-ZSkeleton4Xi: " + str(get_kskeleton4xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)  
                
        return get_kskeleton4xi()
                                
                            
    #</methodize4xi>                                                         
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "sense-of-KSkeleton4Xi" usage = "senses KSkeleton4Xi class objects">
    #<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; ACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def sense(self):
        '''
        senses KSkeleton4Xi class objects
        '''
             
        class2print = 'KSkeleton4Xi'
        method2print = 'sense'
        

        # -------------------------------------------------------------------------------------------------------------------------------------------
        message2print = "{(Step 1/5) stepping" + "; (Step 1/5)-stepping-by-sense-of-KSkeleton4Xi: " + "~~"  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # -------------------------------------------------------------------------------------------------------------------------------------------        

        message2print = "{(Step 1/5) started" + "; sense-of-KSkeleton4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
   
        # -------------------------------------------------------------------------------------------------------------------------------------------
        message2print = "{(Step 2/5) stepping" + "; (Step 2/5)-stepping-by-sense-of-KSkeleton4Xi: " + "~ sensing ~"  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # -------------------------------------------------------------------------------------------------------------------------------------------        
     
        message2print = "{(Step 2/5) sensing" + "; KSkeleton4Xi-sensing-by-sense-of-KSkeleton4Xi: " + str(KSkeleton4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
                     
        # -------------------------------------------------------------------------------------------------------------------------------------------
        message2print = "{(Step 3/5) stepping" + "; (Step 3/5)-stepping-by-sense-of-KSkeleton4Xi: " + "~ getting object knowledge ~"  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # -------------------------------------------------------------------------------------------------------------------------------------------        
           
        kb2xi = sense_object4xi(self)
        
        message2print = "{(Step 3/5) got" + "; knowledgebase2xi-got-by-sense-of-KSkeleton4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                
        # -------------------------------------------------------------------------------------------------------------------------------------------
        message2print = "{(Step 4/5) stepping" + "; (Step 4/5)-stepping-by-sense-of-KSkeleton4Xi: " + "~ adding knowledge~"  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # -------------------------------------------------------------------------------------------------------------------------------------------        
        try:
            kb2xi['classification-of-kskeleton2xi'] = self._classification 
            kb2xi['environment-of-kskeleton2xi'] = self._environment         
            kb2xi['pray-of-kskeleton2xi'] = self._pray 
            kb2xi['environment-of-kskeleton2xi'] = self._environment     
        except:
            message2print = "{yielded" + "; kb2xi-yielded-by-sense-of-KSkeleton4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
                
        message2print = "{(Step 4/5a) set" + "; knowledgebase2xi-set-by-sense-of-KSkeleton4Xi to: " + str(kb2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
                
        message2print = "{(Step 4/5b) sensed" + "; KSkeleton4Xi-sensed-by-sense-of-KSkeleton4Xi: " + str(KSkeleton4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                             
        
        # -------------------------------------------------------------------------------------------------------------------------------------------
        message2print = "{(Step 5/5) stepping" + "; (Step 5/5)-stepping-by-sense-of-KSkeleton4Xi: " + "~~"  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # -------------------------------------------------------------------------------------------------------------------------------------------        
           
        message2print = "{(Step 5/5) returning" + "; knowledgebase2xi-returning-by-sense-of-KSkeleton4Xi: " + str(kb2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
                                   
          
        return kb2xi
        
      
    #</methodize4xi>
    
        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "reason-of-KSkeleton4Xi" usage = "reasons KSkeleton4Xi class objects">
    #<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; ACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def reason(self):
        '''
        reasons KSkeleton4Xi class objects
        '''
              
        class2print = 'KSkeleton4Xi'
        method2print = 'reason'

        # -------------------------------------------------------------------------------------------------------------------------------------------
        message2print = "{(Step 1/5) stepping" + "; (Step 1/5)-stepping-by-reason-of-KSkeleton4Xi: " + "~~"  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # -------------------------------------------------------------------------------------------------------------------------------------------        


        message2print = "{(Step 1/5a) started" + "; reason-of-KSkeleton4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
   
        # -------------------------------------------------------------------------------------------------------------------------------------------
        message2print = "{(Step 2/5) stepping" + "; (Step 2/5)-stepping-by-reason-of-KSkeleton4Xi: " + "~~"  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # -------------------------------------------------------------------------------------------------------------------------------------------        
    
        message2print = "{(Step 2/5) reasoning" + "; KSkeleton4Xi-reasoning-by-reason-of-KSkeleton4Xi: " + str(KSkeleton4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
                
        
        # -------------------------------------------------------------------------------------------------------------------------------------------
        message2print = "{(Step 3/5) stepping" + "; (Step 3/5)-stepping-by-reason-of-KSkeleton4Xi: " + "~~"  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # -------------------------------------------------------------------------------------------------------------------------------------------        
          
        kb4xi = reason_object4xi(self)
        
        message2print = "{(Step 3/5) got" + "; knowledgebase4xi-got-by-reason-of-KSkeleton4Xi: " + str(kb4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                
        
        # -------------------------------------------------------------------------------------------------------------------------------------------
        message2print = "{(Step 4/5) stepping" + "; (Step 4/5)-stepping-by-reason-of-KSkeleton4Xi: " + "~~"  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # -------------------------------------------------------------------------------------------------------------------------------------------        
        try:    
            kb4xi['theater-of-kskeleton2xi'] = "Antarctic Sea"        
        except:
            message2print = "{yielded" + "; kb4xi-yielded-by-reason-of-KSkeleton4Xi: " + str(kb4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
        
        message2print = "{(Step 4/5a) set" + "; knowledgebase4xi-set-by-reason-of-KSkeleton4Xi to: " + str(kb4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
                
                                
        message2print = "{(Step 4/5b) reasoned" + "; KSkeleton4Xi-reasoned-by-reason-of-KSkeleton4Xi: " + str(KSkeleton4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        
        # -------------------------------------------------------------------------------------------------------------------------------------------
        message2print = "{(Step 5/5) stepping" + "; (Step 5/5)-stepping-by-reason-of-KSkeleton4Xi: " + "~~"  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # -------------------------------------------------------------------------------------------------------------------------------------------        
          
        message2print = "{(Step 5/5) returning" + "; knowledgebase4xi-returning-by-reason-of-KSkeleton4Xi: " + str(kb4xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
                            
          
        return kb4xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
    
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "ace-of-KSkeleton4Xi" usage = "aces KSkeleton4Xi class objects">
    #<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; ACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def ace(self):
        '''
        aces KSkeleton4Xi class objects 
        '''
     
        class2print = 'KSkeleton4Xi'
        method2print = 'ace'
        

        # -------------------------------------------------------------------------------------------------------------------------------------------
        message2print = "{(Step 1/5) stepping" + "; (Step 1/5)-stepping-by-ace-of-KSkeleton4Xi: " + "~~"  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # -------------------------------------------------------------------------------------------------------------------------------------------        

        message2print = "{(Step 1/5a) started" + "; ace-of-KSkeleton4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
   
        # -------------------------------------------------------------------------------------------------------------------------------------------
        message2print = "{(Step 2/5) stepping" + "; (Step 2/5)-stepping-by-ace-of-KSkeleton4Xi: " + "~~"  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # -------------------------------------------------------------------------------------------------------------------------------------------        
     
        message2print = "{(Step 2/5b) acing" + "; KSkeleton4Xi-acing-by-ace-of-KSkeleton4Xi: " + str(KSkeleton4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
                 
        
        # -------------------------------------------------------------------------------------------------------------------------------------------
        message2print = "{(Step 3/5) stepping" + "; (Step 3/5)-stepping-by-ace-of-KSkeleton4Xi: " + "~~"  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # -------------------------------------------------------------------------------------------------------------------------------------------        
          
        kb8xi = ace_object4xi(self)  
        
        message2print = "{(Step 3/5) got" + "; knowledgebase8xi-got-by-ace-of-KSkeleton4Xi: " + str(kb8xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                


        # -------------------------------------------------------------------------------------------------------------------------------------------
        message2print = "{(Step 4/5) stepping" + "; (Step 4/5)-stepping-by-ace-of-KSkeleton4Xi: " + "~~"  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # -------------------------------------------------------------------------------------------------------------------------------------------        
        try:      
            kb8xi['mission-of-kskeleton2xi'] = "Monitoring killer-whales in Antartic Seas"             
        except:
            message2print = "{yielded" + "; kb8xi-yielded-by-ace-of-KSkeleton4Xi: " + str(kb8xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
          
        message2print = "{(Step 4/5a) set" + "; knowledgebase8xi-set-by-ace-of-KSkeleton4Xi to: " + str(kb8xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
                        
                        
        
        message2print = "{(Step 4/5b) aced" + "; KSkeleton4Xi-aced-by-ace-of-KSkeleton4Xi: " + str(KSkeleton4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        
        # -------------------------------------------------------------------------------------------------------------------------------------------
        message2print = "{(Step 5/5) stepping" + "; (Step 5/5)-stepping-by-ace-of-KSkeleton4Xi: " + "~~"  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # -------------------------------------------------------------------------------------------------------------------------------------------        
         
        message2print = "{(Step 5/5) returning" + "; knowledgebase8xi-returning-by-ace-of-KSkeleton4Xi: " + str(kb8xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
                                  
        
        return kb8xi
        
        # -----------------------------------------------------------------------------------------
        #
        # ----------------------------------------------------------------------------------------- 
    #</methodize4xi>
#</class4xi>
#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_kskeleton4xi.txt
#   sense-test-kskeleton4xi.xml
#   reason-test-kskeleton4xi.xml
#   ace-test-kskeleton4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 
#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of kskeleton4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
